quit -sim
set VAR_DIR admxrc7v1

# Select simulation of 7vx485t and 7v585t with GTX transceivers
set VAR_GT "x"

# Delete existing libraries
file delete -force -- work
vlib work

# Compile source code
# ADB3 OCP library
vcom -93 "../../../common/adb3_ocp/adb3_ocp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_comp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_cross_clk_dom.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_full2lite_b.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_l_split.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_l_ictrl.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_inc_pkg_syn_ngc_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_target/mptl_if_target_netlist_${VAR_DIR}${VAR_GT}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_target/mptl_if_target_wrap_${VAR_DIR}${VAR_GT}.vhd"

# Chipscope simulation block (optional)
#vcom -93 "../../../common/chipscope/blk_chipscope_sim.vhd"

# itest design
vcom -93 "../common/blk_itest_clocks.vhd"
vcom -93 "../common/itest.vhd"

# Compile testbench source code
# ADB3 OCP testbench
vcom -93 "../../../common/adb3_ocp/adb3_ocp_mux_b.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_tbx_pkg.vhd"

# ADB3 OCP probe
vcom -93 "../../../common/adb3_probe/adb3_probe_pkg.vhd"
vcom -93 "../../../common/adb3_probe/adb3_ocp_transaction_probe_sim.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_tb_inc_pkg_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl128_gtx6_interface.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl_if_bridge_netlist_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl_if_bridge_wrap_${VAR_DIR}.vhd"

# itest Testbench
vcom -93   "../${VAR_DIR}/test_itest_clocks_${VAR_DIR}.vhd"
vcom -93   "../common/test_itest_app.vhd"
vcom -93   "../common/test_itest.vhd"

vsim -t ps -L unisim test_itest

set VAR_USE       Full_MPTL
set VAR_SER_WIDTH [examine /adb3_target_inc_pkg/MPTL_SER_WIDTH]
set VAR_MODEL     [examine /adb3_target_tb_inc_pkg/MODEL_NAME]

set wave_pat {
/test_itest/*
/test_itest/test_itest_app_i/*
/test_itest/uut/*

/test_itest/uut/ds_reg_cross_clk_dom_i/*
/test_itest/uut/adb3_ocp_full2lite_b_i/*
/test_itest/uut/adb3_ocp_l_split_i/*
/test_itest/uut/adb3_ocp_l_ictrl_i/*
}

view signals
view structure
view wave -title "itest (${VAR_MODEL} gt${VAR_GT}, MPTLx${VAR_SER_WIDTH}, ${VAR_USE})"

radix hex

foreach pattern $wave_pat {
add wave -group $pattern $pattern
}
configure wave -signalnamewidth 1

if { $argc < 1 } {
  run 1 ms
} else {
  run $1
  quit -sim
}