#
# itest-admxrc7v1-7vx330t.tcl
#
# Creates PlanAhead project for the ITEST example FPGA design targetting the
# ADM-XRC-7V1 with 7VX330T device.
#
# Usage: run this script from PlanAhead in batch mode, e.g.
#
#   planahead -mode batch -source admxrc7v1/planahead_scripts/itest-admxrc7v1-7vx330t.tcl
#
# Requirements:
#
# 1. The XILINX PlanAhead tools must be in the PATH of the shell.
#
# 2. The environment variable XILINX_PLANAHEAD must point to your PlanAhead
#    installation.
#
# These requirements can normally be satisfied by running/sourcing the
# script/batch file settings32.bat, settings64.bat or settings.sh (whichever
# is appropriate for your development machine) that is provided by the ISE
# tools.
#
# Notes:
#
# As of PlanAhead 13.2, bitgen options must always be entered manually at the
# end of an implementation run when generating a bitstream. They cannot be
# set once when a project is created.
#
# In the PlanAhead GUI, when implementing a project, the options to pass
# in the "More Options" field of the "Generate Bitstream" dialog box are:
#
#   -g drivedone:yes -g unusedpin:pullnone -g compress
#
# In particular, The option "-g unusedpin:pullnone" is MANDATORY and MUST be
# used in order to ensure correct operation of an FPGA design in Alpha Data
# hardware.
#

set design "itest"
set model "admxrc7v1"
set top "${design}"
set sim_top "test_${design}"
set device "7vx330t"
set package "ffg1761"
set speed "1"

# Pull in sources definitions that are invariant over all devices
source "${model}/planahead_scripts/itest-${model}.tcl"

# Source the script that actually makes the PlanAhead project
source "../makeppr.tcl"
