quit -sim
set VAR_DIR admxrc7k1

# Delete existing libraries
file delete -force -- work
vlib work

# Compile source code
# ADB3 OCP library
vcom -93 "../../../common/adb3_ocp/adb3_ocp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_comp_pkg.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_inc_pkg_sim_ocp_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_target/mptl_if_target_wrap_sim_${VAR_DIR}.vhd"

# SIMPLEDMA design
vcom -93 "../common/simpledma.vhd"

# Compile testbench source code
# ADB3 OCP testbench
vcom -93 "../../../common/adb3_ocp/adb3_ocp_tbx_pkg.vhd"

# ADB3 OCP probe
vcom -93 "../../../common/adb3_probe/adb3_probe_pkg.vhd"
vcom -93 "../../../common/adb3_probe/adb3_ocp_transaction_probe_sim.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_tb_inc_pkg_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl_if_bridge_wrap_sim_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/test_board_clks_${VAR_DIR}.vhd"

# SIMPLEDMA Testbench
vcom -93 "../common/test_simpledma.vhd"

vsim -t ps test_simpledma

set VAR_USE       OCP_Only
set VAR_SER_WIDTH [examine /adb3_target_inc_pkg/MPTL_SER_WIDTH]
set VAR_MODEL     [examine /adb3_target_tb_inc_pkg/MODEL_NAME]

set wave_pat {
/test_simpledma/*
/test_simpledma/uut/*
}

set wave_rad {
hexadecimal {data q}
}

view signals
view structure
view wave -title "SIMPLEDMA (${VAR_MODEL}, MPTLx${VAR_SER_WIDTH}, ${VAR_USE})"

foreach pattern $wave_pat {
add wave -group $pattern $pattern
}
configure wave -signalnamewidth 1

foreach {radix signals} $wave_rad {
foreach signal $signals {
catch {property wave -radix $radix $signal}
}
}

radix hex

if { $argc < 1 } {
  run 1 ms
} else {
  run $1
  quit -sim
}