quit -sim
set VAR_DIR admxrc7v1

# Select simulation of 7vx485t and 7v585t with GTX transceivers
set VAR_GT "x"

# Delete existing libraries
file delete -force -- work
vlib work

# Compile source code
# ADB3 OCP library
vcom -93 "../../../common/adb3_ocp/adb3_ocp_pkg.vhd"
vcom -93 "../../../common/adb3_ocp/adb3_ocp_comp_pkg.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_inc_pkg_syn_ngc_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_target/mptl_if_target_netlist_${VAR_DIR}${VAR_GT}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_target/mptl_if_target_wrap_${VAR_DIR}${VAR_GT}.vhd"

# SIMPLEDMA design
vcom -93 "../common/simpledma.vhd"

# Compile testbench source code
# ADB3 OCP testbench
vcom -93 "../../../common/adb3_ocp/adb3_ocp_tbx_pkg.vhd"

# ADB3 OCP probe
vcom -93 "../../../common/adb3_probe/adb3_probe_pkg.vhd"
vcom -93 "../../../common/adb3_probe/adb3_ocp_transaction_probe_sim.vhd"

# ADB3 Target
vcom -93 "../../../common/adb3_target/${VAR_DIR}/adb3_target_tb_inc_pkg_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl128_gtx6_interface.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl_if_bridge_netlist_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/mptl_bridge/mptl_if_bridge_wrap_${VAR_DIR}.vhd"
vcom -93 "../../../common/adb3_target/${VAR_DIR}/test_board_clks_${VAR_DIR}.vhd"

# Simpledma Testbench
vcom -93 "../common/test_simpledma.vhd"

vsim -t ps test_simpledma

set VAR_USE       Full_MPTL
set VAR_SER_WIDTH [examine /adb3_target_inc_pkg/MPTL_SER_WIDTH]
set VAR_MODEL     [examine /adb3_target_tb_inc_pkg/MODEL_NAME]

set wave_pat {
/test_simpledma/*
/test_simpledma/uut/*
}

view signals
view structure
view wave -title "simpledma (${VAR_MODEL} gt${VAR_GT}, MPTLx${VAR_SER_WIDTH}, ${VAR_USE})"

radix hex

foreach pattern $wave_pat {
add wave -group $pattern $pattern
}
configure wave -signalnamewidth 1

if { $argc < 1 } {
  run 1 ms
} else {
  run $1
  quit -sim
}